DOTS-Schraffuren auf SOLID ändern / Lisp
Peter2 30. Sep. 2009, 19:51

Guten Abend

ich muss automatisch bestehende Schraffuren aus DOT in SOLID umwandeln. Ein Blick auf die Gruppencodes zeigt doch massive Strukturunterschiede.

Gibt es hier eine einfache Lösung oder wird das aufwendiger ...?

Peter

CAD-Huebner 30. Sep. 2009, 20:01

Eine einfache Lösung (mit Command) gibts fast immer.

Code:
(defun C:modhatch ( / hatchobj)
  (Prompt "\nUmwandlung des Schraffurmusters zu SOLID")
  (setq hatchobj (car (entsel "\Scharffurobjekt wählen:")))
  (if (and (= "HATCH" (cdr (assoc 0 (entget hatchobj)))))
    (command "_-hatchedit" hatchobj "_prop" "Solid")
  )

Peter2 30. Sep. 2009, 20:12

Zitat:
Original erstellt von CAD-Huebner:
...(command "_-hatchedit" hatchobj "_prop" "Solid")...

Oops - da ist mir wieder ein Standard entgangen (hätte ich mit Doppelklick auch finden können  )

Besten Dank und guten Abend 

Peter

Dorfy 01. Okt. 2009, 09:17

Hi Peter,
mal nen Versuch ohne command

  (setq hatch (vlax-ename->vla-object (car (entsel "\nHatch:"))))
  (vla-SetPattern hatch acHatchPatternTypePreDefined "SOLID")

CAD-Huebner 03. Sep. 2020, 19:41

Ich bin heute per PM gefragt worden, ob man das makro auch noch mit einem anschließenden Farbwechsel verbinden kann.
Klar kann man :=)

Code:
; CAD-Huebner - 03.09.2020
; kleine Erweiterung für den Farbwechsel mit EIGÄNDR / _CHPROP
(defun C:modhatch ( / hatchobj)
  (Prompt "\nUmwandlung des Schraffurmusters zu SOLID mit TrueColor weiß")
(setq hatchobj (car (entsel "\nSchraffurobjekt wählen:")))
(if (and (= "HATCH" (cdr (assoc 0 (entget hatchobj)))))
    (progn
  (command "_-hatchedit" hatchobj "_prop" "Solid")
      (command "_chprop" hatchobj "" "_color" "_Truecolor" "255,255,255" "")
    )
)


Hmmy 09. Sep. 2020, 07:10

@CAD-Huebner,

danke für diese Erweiterung, diese erleichtert mir die Arbeit um einiges 

@all,

ich war der, welcher per PN angefragt hatte 

Gruß Stefan